<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
  <title>debconf5 | See you in hel</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<style type="text/css" media="all">@import "http://www.debconf.org/debconf5/misc/drupal.css";</style>
<style type="text/css">@import url(http://www.debconf.org/debconf5/modules/event/event.css);</style>
<link rel="alternate" type="application/rss+xml" title="RSS" href="http://www.debconf.org/debconf5/node/feed" />

  <style type="text/css" media="all">@import "http://www.debconf.org/debconf5/themes/debconf5/style.css";</style>

  <script type="text/javascript"> </script>
</head>

<body bgcolor="#ffffff" >

<div class="hide"><a href="http://www.debconf.org/debconf5/#content" title="Skip navigation." accesskey="2">Skip navigation</a>.</div>
      <!--a href="http://www.debconf.org/debconf5/" title="Home"><img src="http://www.debconf.org/debconf5/files/logo.png" alt="Home" width="144" height="63" border="0" /></a-->
      <!--div class='site-name'><a href="http://www.debconf.org/debconf5/./" title="Home">debconf5</a></div-->
<table id="top_line" border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>

    <td width="15"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_left_15.png"></td>
    <td class="middle" width="100%"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png"></td>
    <td width="15"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_right_15.png"></td>
  </tr>
</table>
<table id="content" border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>	
	<td colspan="5">
		<table id="primary-menu" summary="Navigation elements." border="0" cellpadding="0" cellspacing="0" width="100%">
		  <tr>

		    <td width="5"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_left.png"></td>
		    <td class="top_left"><a href="http://www.debconf.org/debconf5/"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_img.jpg"></a></td>
		    <td class="top_right" width="219" valign="top">
			   <table>
				<tr>
				  <td colspan="6"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" height="10"></td>
				</tr>
				<tr>
				  <td><a href="http://www.debconf.org/debconf5/"><img src="http://www.debconf.org/debconf5/themes/debconf5/home.jpg"></a></td>

				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/nav_divider.jpg"></td>
				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" width="10" height="29"></td>
				  <td><a href="http://www.debconf.org/debconf5/search"><img src="http://www.debconf.org/debconf5/themes/debconf5/search.jpg"></a></td>
				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" width="10"></td>
				</tr>
				<tr>
				  <td colspan="6"><form action="http://comas.linux-aktivaattori.org/comas/general/proposals/search" method="post">
    				    <div id="search">

  		  	 	  	<input class="form-text" type="text" size="15" value="" name="keys" alt="Enter the terms you wish to search for." />
    				      	<input class="form-submit" type="submit" value="Search" alt="submit" />
				        </div>
				      </form></td>	
				</tr>
			   </table>
			</td>
		    <td width="5"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_right.png"></td>
		  </tr>

		</table>
		<table id="bottom_line" border="0" cellpadding="0" cellspacing="0" width="100%">
		  <tr>
		    <td class="middle" width="100%"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" height="7"></td>
		  </tr>
		</table>	
	</td>
  </tr>
  <tr>
  	<td colspan="5">
<div id="container">
<br/>
	<div id="comas" style="margin-left: 4%">


<h1>FAI -- the Fully Automatic Installation</h1>

<h2>Proposal details:</h2>

<table class="comas-table" width=100%>

<tr>
<td class="name">Abstract:</td>
<td class="input"><p><div class="hft-lines">FAI is an automated system to install a Debian<br />
GNU/Linux operating system on a bunch of computers<br />
with a variety of hardware configurations or on a<br />
homogeneous cluster of PCs. You can take virgin<br />
PCs called install clients, turn on the power and<br />
after a few minutes the operation system and the<br />
applications are installed, configured and running<br />
on all hosts, without any interaction<br />
necessary. Thus, it's an unattended scalable<br />
method for installing and updating a cluster with<br />
little effort involved.<br />
<br />
FAI uses a collection of shell and perl scripts<br />
for the installation process. It was developed for<br />
installing the Debian Linux distribution but has<br />
also been ported to install SUN Solaris on SPARC<br />
hardware and to install the Ubuntu Linux<br />
distribution.<br />
A fully automatic installation with FAI needs<br />
several services and data provided by the FAI<br />
install server. A DHCP daemon should provide the<br />
network configuration and the name of the initial<br />
PXE boot file.  Some FAI specific data as the FAI<br />
flags and the name of the FAI install kernel are<br />
provided by the PXE configuration file. A TFTP<br />
daemon gives access to the install kernel<br />
image. Both, a 2.4 kernel or a 2.6 kernel can be<br />
used during the installation. All clients must<br />
have NFS access to a nfsroot directory which is<br />
the complete filesystem during the installation<br />
for all clients. You can choose between NFS, HTTP<br />
or FTP access to a Debian mirror to access all<br />
software packages. The information about how to<br />
install and configure the clients is stored in<br />
files in the configuration space which is by<br />
default a NFS mounted directory but a CVS<br />
repository is also supported.<br />
By default, the install client is booted via a<br />
network card using the the PXE environment, but<br />
also booting via BOOTP or from floppy or from<br />
CD-ROM is supperted. Without using an initial<br />
ramdisk the client mounts its root filesystem<br />
(called nfsroot) via NFS from the install<br />
server. All install clients can share the same<br />
nfsroot since it is mounted read only. A small<br />
ramdisk is created where log files can be saved<br />
to. So, a complete Linux system is running on the<br />
client without using a local harddisk and with<br />
only a small RAM size needed. This is like running<br />
as diskless machine. Then some additional<br />
installation data is received. This includes the<br />
list of flags (eg. debug, verbose, sshd), the<br />
location of the remote configuration directory and<br />
the type of action that should be performed<br />
(sysinfo or install). On request a secure shell<br />
daemon for remote logins during installation is<br />
started.<br />
Now, scripts in the directory /fai/class/ of the<br />
form S[0-9]* are executed in alphabetical order<br />
and can define classes and variables. Classes are<br />
used in all further tasks of the<br />
installation. Classes determine which<br />
configuration file to choose from a list of<br />
available templates. To determine which config<br />
file to use, an install clients searches the list<br />
of defined classes and uses all configuration<br />
files that match a class name. It's also possible<br />
to select only the configuration file with the<br />
highest priority since the order of classes<br />
define the priority for low to high. There are<br />
some predefined classes (DEFAULT, LAST and the<br />
hostname), but classes can also be listed in a<br />
file or defined dynamically by scripts. So it's<br />
easy to define a class depending on the subnet<br />
information or on some hardware that is available<br />
on the install client. Variables are used for<br />
defining things like the root password, the<br />
timezone, the name of the kernel image package,<br />
the keyboard layout. Next, the local harddisks<br />
are partitioned using a configuration file in<br />
/fai/disk config/.  This configuration file<br />
defines in an easy and flexible way how the disk<br />
has to be partitioned, which type of filesystems<br />
(ext2, ext3, Reiserfs, XFS, swap) to create and<br />
where to mount them. For example it's easy to<br />
define a range for the size of a partition (like<br />
100-800 MB), or to preserve the existing data on<br />
a certain partition.<br />
Then, depending on the defined classes, a perl<br />
script selects all software configuration files<br />
from /fai/package config/ and creates a list of<br />
packages that will be installed using the Debian<br />
command apt-get. This is done in a chroot<br />
environment. After that, scripts in /fai/scripts/<br />
which match a class name are executed to configure<br />
the system to your local needs. These scripts can<br />
be shell, perl, expect or cfengine scripts. They<br />
can install the kernel, call the boot loader, set<br />
the root password, add lines to /etc/fstab or<br />
/etc/exports and can edit other files.  You can<br />
also use the special FAI commands fcopy to install<br />
ready to use template files to the new system<br />
using the classes. Finally, after all log files of<br />
the installation are copied locally and to the<br />
install server, the new operating system will be<br />
booted from the local disk. The whole installation<br />
only takes a few minutes, for eg. an Athlon XP<br />
1600+ with 100Mbit LAN needs about 6 minutes when<br />
installing 1 Gbyte of software.<br />
<br />
Configuration files are shared among groups of<br />
similar computers using the class concept, so you<br />
need not create a configuration for every new<br />
host. Since the nfsroot is shared among all<br />
install clients only constant disk space is<br />
required on the install server. Therefore, FAI is<br />
a scalable method to install a large number of<br />
machines. It's also very flexible since all<br />
installation tasks can be redefined or extended<br />
using hooks.<br />
A new approach can now put all parts from the<br />
install server onto a bootable CD. This CD<br />
performs the automatic installation without the<br />
need for a network connection. Also, preseeding of<br />
the debconf database is supported.<br />
<br />
  The homepage of FAI is<br />
  http://www.informatik.uni-koeln.de/fai<br />
<br />
About the workshop<br />
<br />
The workshop will first motivate the need of an<br />
automated installation for different computer<br />
environments, and why it's important to plan the<br />
computer infrastructure. The setup of an install<br />
server will be described and how the clients are<br />
prepared for booting. Then the technical details<br />
of FAI are described especially how to create and<br />
modify the different configuration files and how<br />
to use the class concept. Also some examples of<br />
FAI installations will be shown. Later a brief<br />
comparison of d-i and FAI will show the different<br />
goals of these installation methods. The workshop<br />
will finish with a live demonstration of a fully<br />
automatic installation.<br />
<br />
<br />
About the Author<br />
<br />
Thomas Lange studied computer science and has now<br />
been working as a system administrator for over<br />
twelve years. Most of his job is done<br />
automatically by shell and perl scripts, which do<br />
the installation and administration of several Sun<br />
Solaris workstation networks. Since 1999 he has<br />
been developing the fully automatic installation<br />
for Debian GNU/Linux, since 2000 he's also a<br />
Debian Developer. He gave several talks and<br />
tutorials about FAI on conferences like Linux<br />
Kongress, SANE, FOSDEM, SUCON, Cebit and at some<br />
local Linux meetings.<br /></div></p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Presentation type:</td>
<td class="input"><p>BOF (45 min)</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Track:</td>
<td class="input"><p>Technical</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Status:</td>
<td class="input"><p>Non-official (i.e. BoF)</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

</table>

<h2>Authors:</h2>

<ul>

<li><p>Thomas Lange</p>


</li>

</ul>

<h2>Files:</h2>

<ul>

</ul>

<center>
<input type="button" value="Go back" onClick="history.go(-1)">
</center>

	</div>
<br/>
<hr/>
</div>
<div id="bottom" class="margin-left: 4%">
&nbsp;<a href="http://www.debconf.org/debconf5">Debconf 5</a><br/> 
&nbsp;&nbsp;&nbsp;Powered by <a href="http://gborg.postgresql.org/project/comas">COMAS</a>, 
the Conference Management System by <a href="http://www.consol.org.mx">CONSOL</a>
</div>
</td>
</tr>
</table>

</body>
</html>

